import 'package:flutter/material.dart';

class Alex extends StatefulWidget {
  final Widget child;
  final Widget alex;
  final Offset offset;
  final LocationBuilder locationBuilder;

  Alex({@required this.child, @required this.alex, this.offset = Offset.zero,this.locationBuilder});

  @override
  _AlexState createState() => _AlexState();
}

typedef LocationBuilder = Offset Function(Rect targetRange,Offset touchPoint);

class _AlexState extends State<Alex> {
  bool isShow = false;
  Offset offset = Offset.zero;
  OverlayEntry entry;
  GlobalKey anchorKey = GlobalKey();


  @override
  void initState() {
    super.initState();

    entry = OverlayEntry(
        builder: (context) => Stack(
          children: <Widget>[
            GestureDetector(
              onTap: () {
                close();
              },
              child: Container(
                color: Colors.transparent,
                width: MediaQuery.of(context).size.width,
                height: MediaQuery.of(context).size.height,
              ),
            ),
            Positioned(
              left: offset.dx,
              top: offset.dy,
              child: Material(
                  child: widget.alex),
            ),
          ],
        ));
  }

  close() {
    if (isShow && entry != null) {
      entry.remove();
      isShow = false;
    }
  }

  toggleFloating(BuildContext context) {
    if (entry == null) return;
    if (!isShow) {
      Overlay.of(context).insert(entry);
    } else {
      entry.remove();
    }
    isShow = !isShow;
  }

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      key: anchorKey,
      onTapDown: (detail) {
        RenderBox renderBox = anchorKey.currentContext.findRenderObject();

        var offsetGlobal = renderBox.localToGlobal(Offset.zero);

        Rect globalRect = Rect.fromPoints(
            offsetGlobal,
            offsetGlobal.translate(
                renderBox.size.width, renderBox.size.height));

        if(widget.locationBuilder!=null){
          offset = widget.locationBuilder(globalRect,detail.globalPosition);
        }else{
          offset = globalRect.bottomLeft.translate(widget.offset.dx, widget.offset.dy);
        }


      },
      onTap: () {
        toggleFloating(context);
      },
      child: widget.child,
    );
  }

}